._?][\w$.?#@~]*">
        <token type="NameFunction"/>
        <push state="instruction-args"/>
      </rule>
      <rule pattern="[\r\n]+">
        <token type="Text"/>
      </rule>
    </state>
    <state name="instruction-args">
      <rule pattern="&#34;(\\&#34;|[^&#34;\n])*&#34;|&#39;(\\&#39;|[^&#39;\n])*&#39;|`(\\`|[^`\n])*`">
        <token type="LiteralString"/>
      </rule>
      <rule pattern="(?:0x[0-9a-f]+|$0[0-9a-f]*|[0-9]+[0-9a-f]*h)">
        <token type="LiteralNumberHex"/>
      </rule>
      <rule pattern="[0-7]+q">
        <token type="LiteralNumberOct"/>
      </rule>
      <rule pattern="[01]+b">
        <token type="LiteralNumberBin"/>
      </rule>
      <rule pattern="[0-9]+\.e?[0-9]+">
        <token type="LiteralNumberFloat"/>
      </rule>
      <rule pattern="[0-9]+">
        <token type="LiteralNumberInteger"/>
      </rule>
      <rule>
        <include state="punctuation"/>
      </rule>
      <rule pattern="r[0-9][0-5]?[bwd]|[a-d][lh]|[er]?[a-d]x|[er]?[sb]p|[er]?[sd]i|[c-gs]s|st[0-7]|mm[0-7]|cr[0-4]|dr[0-367]|tr[3-7]">
        <token type="NameBuiltin"/>
      </rule>
      <rule pattern="[a-z$._?][\w$.?#@~]*">
        <token type="NameVariable"/>
      </rule>
      <rule pattern="[\r\n]+">
        <token type="Text"/>
        <pop depth="1"/>
      </rule>
      <rule>
        <include state="whitespace"/>
      </rule>
    </state>
    <state name="preproc">
      <rule pattern="[^;\n]+">
        <token type="CommentPreproc"/>
      </rule>
      <rule pattern=";.*?\n">
        <token type="CommentSingle"/>
        <pop depth="1"/>
      </rule>
      <rule pattern="\n">
        <token type="CommentPreproc"/>
        <pop depth="1"/>
      </rule>
    </state>
    <state name="whitespace">
      <rule pattern="\n">
        <token type="Text"/>
      </rule>
      <rule pattern="[ \t]+">
        <token type="Text"/>
      </rule>
      <rule pattern=";.*">
        <token type="CommentSingle"/>
      </rule>
    </state>
  </rules>
</lexer>